import { Injectable } from '@angular/core';
import { Subject, Observable } from 'rxjs';

@Injectable({
  providedIn: 'root'
})
export class WebsocketService {

  constructor() { }
  ws: WebSocket;//定义websocket
  private subject;
  // 连接websocket
  connectWs(url, data): Observable<any> {
    var postData = data;
    if (this.ws != null) { this.ws.close() };
    if (this.subject) { this.subject = null };
    this.ws = new WebSocket(url);
    this.subject = new Subject<any>();
    let that = this;
    this.ws.onopen = function (event) {
      //socket 开启后执行，可以向后端传递信息
      var sendData = JSON.stringify(postData)
      that.ws.send(sendData);
      console.log('open')
    }
    this.ws.onmessage = function (event) {
      //socket 获取后端传递到前端的信息
      console.log('onmessage')
      if (event.data && event.data.length > 1) {
        that.subject.next(JSON.parse(event.data));
      }
    }

    this.ws.onerror = function (event) {
      //socket error信息
      console.log('error')

    }
    this.ws.onclose = function (event) {
      //socket 关闭后执行
      console.log('close')
    }

    return that.subject.asObservable();
  }

  // 断开websocket
  closeWs() {
    this.ws.close()
  }





}
